% Doing things naively now
% can do things more efficiently (?)
% Note that W is obtaned by taking the negative of Deriv2
% second derivative wrt f
function Deriv2 = deriv2_log_likelihood_gppe_fast(f, sigma, all_pairs, ...
    idx_global_1, idx_global_2, M, N)
M = length(all_pairs);
n = M*N;
Deriv2 = zeros(n, n);

all_diag_idx = sub2ind([n,n],1 : n, 1 :n);
z = ( f(idx_global_1) - f(idx_global_2) )/sigma;
cdf_val = normcdf(z); pdf_val = normpdf(z);
ratio = pdf_val./cdf_val;
val = - (1/sigma^2) .* ratio .* (z + ratio);

ind = sub2ind([n,n],idx_global_1, idx_global_2);
Deriv2(ind) = - val;
    
ind_trans = sub2ind([n,n],idx_global_2, idx_global_1);
Deriv2(ind_trans) = - val;
    
% Now the diagonal
Deriv2(all_diag_idx) = Deriv2(all_diag_idx) + get_cumulative_val(idx_global_1, val, n)';
Deriv2(all_diag_idx) = Deriv2(all_diag_idx) + get_cumulative_val(idx_global_2, val, n)';



return;

 